<?php

namespace App\Wrangler\Components;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use Medialight\Textstem\Helpers\MediaAsset;
use Medialight\Textstem\Models\WranglerPage;
use Medialight\Textstem\Wrangler\ActiveComponent;

class Embed  extends ActiveComponent
{
    public static string $description = "Display embedded content (Youtube, Vimeo, Slideshare, Miro, GoogleMaps)";
    public static string $version = '1.0.1';

    public $config;

    public $editSetup = [
        [
            'name' => 'template',
            'controltype' => 'select-template',
            'value' => 'default',

        ],
        [
            'name' => 'content',
            'controltype' => 'videoembed',
            'value' => '',
            'label' => 'url',
        ],
        [
            'name' => 'aspect',
            'controltype' => 'text',
            'value' => '16:9',
            'label' => 'Aspect',
            'placeholder' => '16:9',
            'size' => 1,
        ],
    ];

    public function __construct($instance)
    {
        parent::__construct($instance);
    }

    public function render(Request $request, WranglerPage $wranglerPage)
    {
        $data = $this->data();
        if ($data['aspect'] == 'video') {
            $data['aspect'] = '16:9';
        }
        return view('wrangler.components.embed.default', $data)->render();
    }

    public function preview()
    {
        $data = $this->data();
        if ($data['aspect'] == 'video') {
            $data['aspect'] = '16:9';
        }

        $data['autoplay'] = false;
        $data['controls'] = true;
        return view('wrangler.components.embed.default', $data)->render();
    }
}
